#ifndef _XPP_WIN32API_PIPES_
   #define _XPP_WIN32API_PIPES_

   #define PIPE_WAIT                            0x00000000
   #define PIPE_NOWAIT                          0x00000001
   #define PIPE_READMODE_BYTE                   0x00000000
   #define PIPE_READMODE_MESSAGE                0x00000002
   #define PIPE_TYPE_BYTE                       0x00000000
   #define PIPE_TYPE_MESSAGE                    0x00000004

   #define PIPE_ACCESS_INBOUND                  0x00000001
   #define PIPE_ACCESS_OUTBOUND                 0x00000002
   #define PIPE_ACCESS_DUPLEX                   0x00000003

   #define FILE_FLAG_WRITE_THROUGH              0x80000000
   #define FILE_FLAG_OVERLAPPED                 0x40000000
   #define FILE_FLAG_NO_BUFFERING               0x20000000
   #define FILE_FLAG_RANDOM_ACCESS              0x10000000
   #define FILE_FLAG_SEQUENTIAL_SCAN            0x08000000
   #define FILE_FLAG_DELETE_ON_CLOSE            0x04000000
   #define FILE_FLAG_BACKUP_SEMANTICS           0x02000000
   #define FILE_FLAG_POSIX_SEMANTICS            0x01000000
   #define FILE_FLAG_OPEN_REPARSE_POINT         0x00200000
   #define FILE_FLAG_OPEN_NO_RECALL             0x00100000

   #define PIPE_UNLIMITED_INSTANCES             255

   #define GENERIC_READ                         0x80000000
   #define GENERIC_WRITE                        0x40000000
   #define GENERIC_EXECUTE                      0x20000000
   #define GENERIC_ALL                          0x10000000

   #define CREATE_NEW                           1
   #define CREATE_ALWAYS                        2
   #define OPEN_EXISTING                        3
   #define OPEN_ALWAYS                          4
   #define TRUNCATE_EXISTING                    5

   #define FILE_SHARE_READ                      0x00000001
   #define FILE_SHARE_WRITE                     0x00000002
   #define FILE_SHARE_DELETE                    0x00000004
   #define FILE_ATTRIBUTE_READONLY              0x00000001
   #define FILE_ATTRIBUTE_HIDDEN                0x00000002
   #define FILE_ATTRIBUTE_SYSTEM                0x00000004
   #define FILE_ATTRIBUTE_DIRECTORY             0x00000010
   #define FILE_ATTRIBUTE_ARCHIVE               0x00000020
   #define FILE_ATTRIBUTE_DEVICE                0x00000040
   #define FILE_ATTRIBUTE_NORMAL                0x00000080
   #define FILE_ATTRIBUTE_TEMPORARY             0x00000100
   #define FILE_ATTRIBUTE_SPARSE_FILE           0x00000200
   #define FILE_ATTRIBUTE_REPARSE_POINT         0x00000400
   #define FILE_ATTRIBUTE_COMPRESSED            0x00000800
   #define FILE_ATTRIBUTE_OFFLINE               0x00001000
   #define FILE_ATTRIBUTE_NOT_CONTENT_INDEXED   0x00002000
   #define FILE_ATTRIBUTE_ENCRYPTED             0x00004000
   #define FILE_NOTIFY_CHANGE_FILE_NAME         0x00000001
   #define FILE_NOTIFY_CHANGE_DIR_NAME          0x00000002
   #define FILE_NOTIFY_CHANGE_ATTRIBUTES        0x00000004
   #define FILE_NOTIFY_CHANGE_SIZE              0x00000008
   #define FILE_NOTIFY_CHANGE_LAST_WRITE        0x00000010
   #define FILE_NOTIFY_CHANGE_LAST_ACCESS       0x00000020
   #define FILE_NOTIFY_CHANGE_CREATION          0x00000040
   #define FILE_NOTIFY_CHANGE_SECURITY          0x00000100
   #define FILE_ACTION_ADDED                    0x00000001
   #define FILE_ACTION_REMOVED                  0x00000002
   #define FILE_ACTION_MODIFIED                 0x00000003
   #define FILE_ACTION_RENAMED_OLD_NAME         0x00000004
   #define FILE_ACTION_RENAMED_NEW_NAME         0x00000005
   #define FILE_CASE_SENSITIVE_SEARCH           0x00000001
   #define FILE_CASE_PRESERVED_NAMES            0x00000002
   #define FILE_UNICODE_ON_DISK                 0x00000004
   #define FILE_PERSISTENT_ACLS                 0x00000008
   #define FILE_FILE_COMPRESSION                0x00000010
   #define FILE_VOLUME_QUOTAS                   0x00000020
   #define FILE_SUPPORTS_SPARSE_FILES           0x00000040
   #define FILE_SUPPORTS_REPARSE_POINTS         0x00000080
   #define FILE_SUPPORTS_REMOTE_STORAGE         0x00000100
   #define FILE_VOLUME_IS_COMPRESSED            0x00008000
   #define FILE_SUPPORTS_OBJECT_IDS             0x00010000
   #define FILE_SUPPORTS_ENCRYPTION             0x00020000
   #define FILE_NAMED_STREAMS                   0x00040000




#endif

