/*****************************
* Source : commonUtils.prg           
* System : <unkown>           
* Author : Phil Ide           
* Created: 14/01/2003             
*                             
* Purpose:                    
* ----------------------------
* History:                    
* ----------------------------
*    14/01/2003 11:16 PPI - Created                
*****************************/
                              
#include "Common.ch"

#define TYPE_CHAR    1
#define TYPE_MEMO    2

#define TYPE_NUM     3
#define TYPE_DATE    4
#define TYPE_LOG     5
#define TYPE_ARRAY   6
#define TYPE_BLOCK   7
#define TYPE_OBJECT  8
#define TYPE_NIL     9

#define TYPE_LIST {'C','M','N','D','L','A','B','O','U'}

Function Var2Stream(x)
   local cType := ValType(x)
   local cRet := ''
   local i := AScan( TYPE_LIST, cType )
   local cTmp

   do case
      case i < 3  // char, memo
         cRet := Chr(i)+U2Bin(Len(x))+x

      case i == 9 // NIL
         cRet := Chr(i)

      case i < 6  // Num, Date, Logical
         cRet := Chr(i)
         cTmp := Var2Char(x)
         cRet += U2Bin(len(cTmp))+cTmp

      case i == 6 // array
         cRet := Chr(i)+U2Bin(len(x))
         for i := 1 to len(x)
            cRet += Var2Stream(x[i])
         next

      case i == 7 // Block
         cRet := Chr(i)
         cTmp := Var2Char(x)
         cRet += U2Bin(len(cTmp))+cTmp


      otherwise // Block, Obj
         cRet := Chr(i)
         cTmp := Var2Bin(x)
         cRet += U2Bin(len(cTmp))+cTmp

   endcase
   return cRet

Function Stream2Var(cStream)
   local nType
   local nLen := 1
   local xRet
   local i

   nType := Asc(cStream[1])

   do case
      case nType < 3
         nLen := Bin2U( SubStr( cStream, 2, 4 ) )
         xRet := SubStr( cStream, 6, nLen )
         nLen++

      case nType == 9
         xRet := NIL // not necessary, but it shows we haven't forgotten

      case nType == 7 // Block
         nLen := Bin2U( SubStr( cStream, 2, 4 ) )
         xRet := Char2Var(SubStr( cStream, 6, nLen ), TYPE_LIST[TYPE_CHAR])
         xRet := &xRet

      case nType < 6
         nLen := Bin2U( SubStr( cStream, 2, 4 ) )
         xRet := Char2Var(SubStr( cStream, 6, nLen ), TYPE_LIST[nType])
         nLen++

      case nType == 6  // array
         nLen := Bin2U( SubStr( cStream, 2, 4 ) )
         xRet := Array(nLen)
         cStream := SubStr( cStream, 6 )
         for i := 1 to nLen
            xRet[i] := Stream2Var(@cStream)
         next
         nLen := 0

      otherwise  // object
         nLen := Bin2U( SubStr( cStream, 2, 4 ) )
         xRet := Bin2Var(SubStr( cStream, 6, nLen ))
         nLen++

   endcase
   if len(cStream) > nLen
      cStream := SubStr( cStream, nLen+1 )
   endif

   return xRet

         
