/*****************************
* Source : npipeb.prg           
* System : <unkown>           
* Author : Phil Ide           
* Created: 27/12/2002             
*                             
* Purpose:                    
* ----------------------------
* History:                    
* ----------------------------
*    27/12/2002 11:00 PPI - Created                
*****************************/
                              
#include "Common.ch"
#include "dll.ch"
#include "pipes.ch"

/*
HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Control\ComputerName\ComputerName
*/

CLASS NamedPipeBase
   PROTECTED:
      VAR nHnd
      VAR cPipeName

      METHOD receive

      CLASS VAR nKernel32

   EXPORTED:
      VAR cargo
      VAR cPeerName
      VAR cIP

      METHOD init
      METHOD write
      METHOD recv
      METHOD disconnect
      METHOD peek
      METHOD pipeName
      METHOD getPeerName

      METHOD WriteFile
      METHOD ReadFile
      METHOD PeekNamedPipe
      METHOD CloseHandle

ENDCLASS

METHOD NamedPipeBase:init()
   ::nHnd := 0
   ::cPipeName := ''
   if ::nKernel32 == NIL
      ::nKernel32 := DllLoad('Kernel32.dll')
   endif
   return (self)

METHOD NamedPipeBase:getPeername()
   return {::cIP,::cPeerName}

METHOD NamedPipeBase:write(cData)
   local nDone := 0
   local cSize
   local cBuff

   cData := Var2Stream(cData)
   cSize := U2Bin(Len(cData))
   cBuff := cSize+cdata
   while len(cBuff) > 0
      ::WriteFile(@cBuff,len(cBuff),@nDone)
      cBuff := substr(cBuff,nDone+1)
   enddo
   return (nDone)

METHOD NamedPipeBase:receive(nBuffLen)
   local cBuff := ''
   local cSubBuff
   local nRead := 0

   default nBuffLen to 1024

   cSubBuff := space(nBuffLen)

   while nBuffLen > 0
      ::ReadFile(@cSubBuff,nBuffLen,@nRead)
      cBuff += left(cSubBuff,nRead)
      nBuffLen -= nRead
   enddo
   return cBuff

METHOD NamedPipeBase:recv()
   local nLen    := 0
   local cData   := ''

   while !::peek()
      sleep(1)
   enddo
   nLen := Bin2U(::receive(4))
   if nLen > 0
      cData := ::receive(nLen)
      cData := Stream2Var(cData)
   endif
   return cData

METHOD NamedPipeBase:disconnect()
   if ::nHnd > 0
      ::CloseHandle()
   endif
   return self

METHOD NamedPipeBase:peek()
   local nPending
   local cBuff := ' '
   local nRead := 0
   local nAvail := 0
   local nRemain := 0

   nPending := ::PeekNamedPipe( @cBuff, 1, @nRead, @nAvail, @nRemain )
   return nPending > 0

METHOD NamedPipeBase:pipeName()
   return ::cPipeName


METHOD NamedPipeBase:PeekNamedPipe( cBuff, nToRead, nRead, nAvail, nRemain )
   STATIC cTemplate

   if cTemplate == NIL
      cTemplate := DllPrepareCall(::nKernel32,DLL_OSAPI,'PeekNamedPipe')
   endif
   return DllExecuteCall(cTemplate,::nHnd, @cBuff, nToRead, @nRead, @nAvail, @nRemain )

METHOD NamedPipeBase:WriteFile( cBuff, nLen, nWritten )
   STATIC cTemplate

   if cTemplate == NIL
      cTemplate := DllPrepareCall(::nKernel32,DLL_OSAPI,'WriteFile')
   endif
   return DllExecuteCall(cTemplate,::nHnd, @cBuff, nLen, @nWritten, NIL )

METHOD NamedPipeBase:ReadFile( cBuff, nLen, nRead )
   STATIC cTemplate

   if cTemplate == NIL
      cTemplate := DllPrepareCall(::nKernel32,DLL_OSAPI,'ReadFile')
   endif
   return DllExecuteCall(cTemplate,::nHnd, @cBuff, nLen, @nRead, NIL )

METHOD NamedPipeBase:CloseHandle()
   STATIC cTemplate

   if cTemplate == NIL
      cTemplate := DllPrepareCall(::nKernel32,DLL_OSAPI,'CloseHandle')
   endif
   return DllExecuteCall(cTemplate,::nHnd)

