/*****************************
* Source : npipes.prg           
* System : <unkown>           
* Author : Phil Ide           
* Created: 18/12/2002             
*                             
* Purpose:                    
* ----------------------------
* History:                    
* ----------------------------
*    18/12/2002 12:54 PPI - Created                
*****************************/
                              
#include "dll.ch"
#include "Common.ch"
#include "pipes.ch"

DLLFUNCTION CreatePipe(@nIn,@nOut,cSec,nLength) USING OSAPI FROM Kernel32.dll
DLLFUNCTION CreateNamedPipeA(@cPipe,nMode1,nMode2,nMax,nIn,nOut,nTOut,pSec) USING OSAPI FROM Kernel32.dll
DLLFUNCTION WaitNamedPipeA(@cPipe,nWait) USING OSAPI FROM Kernel32.dll
DLLFUNCTION ConnectNamedPipe(nPipe,pSec) USING OSAPI FROM Kernel32.dll
DLLFUNCTION DisconnectNamedPipe(nPipe) USING OSAPI FROM Kernel32.dll
DLLFUNCTION FlushFileBuffers(nPipe) USING OSAPI FROM Kernle32.dll

CLASS NamedPipeServer FROM NamedPipeBase
   EXPORTED:
      METHOD init
      METHOD createPipe
      METHOD acceptConnection
      METHOD disconnect
      METHOD serverPipeName
      METHOD remotePipeName

ENDCLASS

METHOD NamedPipeServer:init()
   ::namedPipeBase:init()
   return (self)

METHOD NamedPipeServer:createPipe(nOpenMode, nPipeMode)
   local cPipeName := CreateUniquePipeName()
   local nMaxInstances := PIPE_UNLIMITED_INSTANCES
   local nOutBuffSize  := 1024 // advisory only, usually ignored
   local nInBuffSize   := 1024 // advisory only, usually ignored
   local nDefTimeOut   := 3000 // timeout to 3 secs
   local pSecurity     := CreateWin32APISecurityStructureForPipes()
   local lOk           := FALSE

   default nOpenMode TO PIPE_ACCESS_DUPLEX+FILE_FLAG_WRITE_THROUGH,;
           nPipeMode TO PIPE_TYPE_BYTE+PIPE_READMODE_BYTE+PIPE_WAIT

   ::nHnd := CreateNamedPipeA(@cPipeName, nOpenMode, nPipeMode,;
              nMaxInstances, nOutBuffSize, nInBuffSize, nDefTimeOut, pSecurity )
   if ::nHnd > 0
      ::cPipeName := substr(cPipeName,10)
      lOk := TRUE
   endif
   return lOk

METHOD NamedPipeServer:acceptConnection()
   local lRet := FALSE
   if ::nHnd > 0
      lRet := ConnectNamedPipe(::nHnd, 0)
   endif
   return lRet

METHOD NamedPipeServer:disconnect()
   local nPipe := ::nHnd
   if ::nHnd > 0
      //FlushFileBuffers(nPipe)      // waits until client has read all data
      DisconnectNamedPipe(nPipe)   // disconnects client, not server
      ::NamedPipeBase:disconnect()  // discard this instance of the pipe
   endif
   return self

METHOD NamedPipeServer:serverPipeName()
   return '\\.\pipe\'+::pipename()

METHOD NamedPipeServer:remotePipeName()
   return '\\'+GetEnv('COMPUTERNAME')+'\pipe\'+::pipename()


